﻿
Partial Class Controls_MapControl
    Inherits System.Web.UI.UserControl
    Private _dataSource As IEnumerable
    Private _VarMap As String = "var map = null;"
    Private _GetMapOpen As String = "function GetMap(){"
    Private _CloseBracket As String = "}"
    Private _LoadMap As String = "map.LoadMap();"
    Private _PinId1 As String = "var pinid1=0;"
    Private _Locs1Array As String = "var locs1 = new Array;"
    Private _MapAddPushpin As String = "map.AddPushpin(pin);"
    Private _IncrementPinId As String = "pinid1++;"
    Private _Latitude As String = "47.6"
    Private _Longitude As String = "-122.33"
    Private _ZoomLevel As Integer = 20

    Public Property ZoomLevel() As Integer
        Get
            Return _ZoomLevel
        End Get
        Set(ByVal value As Integer)
            _ZoomLevel = value
        End Set
    End Property


    Public Property DataSource() As XmlDataSource
        Get
            Return _dataSource
        End Get
        Set(ByVal value As XmlDataSource)
            _dataSource = value
        End Set
    End Property

    Private Function NewNamedMap(ByVal MapName As String) As String
        Return "map = new VEMap('" & MapName & "');"
    End Function

    Private Function NewLocation(ByVal longatude As String, ByVal latitude As String) As String
        Return "var loc = new VELatLong(" & longatude & "," & latitude & ");"
    End Function

    Private Function AddPushPin(ByVal Arr As String, ByVal Location As String) As String
        Return Arr & ".push(" & Location & ");"
    End Function

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub
    Private Sub CreateMap()
        'Dim cssVE As HtmlLink = New HtmlLink()
        'cssVE.Href = ConfigurationManager.AppSettings("VirtualEarthCSS").ToString()
        'cssVE.Attributes.Add("rel", "stylesheet")
        'cssVE.Attributes.Add("type", "text/css")
        'Page.Header.Controls.Add(cssVE)

        Dim cscriptManager As ClientScriptManager = Page.ClientScript

        cscriptManager.RegisterClientScriptInclude("VEControlInclue", ConfigurationManager.AppSettings("VirtualEarthJavaScriptLibrary").ToString())

        Controls.Add(New LiteralControl("<div id='MyNewMap' style=""position:relative; width:800px; height:600px;""></div>"))

        If Not _dataSource Is Nothing Then
            Me.Page.ClientScript.RegisterClientScriptBlock(GetType(String), "OnLoad", MapWithDatasource)
        Else
            Me.Page.ClientScript.RegisterClientScriptBlock(GetType(String), "OnLoad", BasicMap)
        End If
    End Sub
    Private Function BasicMap() As String
        Dim str As String = ""
        str = "<script language=""JavaScript"">"

        If ConfigurationManager.AppSettings("startLatitude").ToString() <> "" And ConfigurationManager.AppSettings("startLongitude").ToString() <> "" Then
            str &= _GetMapOpen & _VarMap & NewNamedMap("MyNewMap") & _
                "map.LoadMap(new VELatLong(" & ConfigurationManager.AppSettings("homeLatitude").ToString() & "," & ConfigurationManager.AppSettings("homeLongitude").ToString() & "), " & ZoomLevel.ToString & ",'h' ,false);" & _CloseBracket
        Else
            str &= _GetMapOpen & _VarMap & NewNamedMap("MyNewMap") & _LoadMap & _CloseBracket
        End If
        str &= "</script>"

        Return str
    End Function
    Private Function MapWithDataSource() As String
        Dim str As New StringBuilder()
        str.Append("<script ")
        str.Append("type=""text/javascript""")
        str.Append(">")
        str.Append(_GetMapOpen & _VarMap & NewNamedMap("MyNewMap") & _LoadMap)
        str.Append(_Locs1Array)
        str.Append(_PinId1)



        Dim i As Integer = 0

        'While DataEnum.MoveNext()
        '    str.Append(NewLocation(XPath("/rss/channel/item/venue/geoLat"), XPath("/rss/channel/item/venue/geoLong")))
        '    str.Append("locs1", "loc")
        '    str.Append("var pin = new VEPushpin(" & i.ToString() & ", locs1[" & i.ToString() & "], null, '" & st3 & "', '" & st4 & "');")
        '    str.Append("map.AddPushpin(pin);")
        '    i += 1
        'End While

        'str.Append("map.SetMapView(locs1);")
        'str.Append(_CloseBracket)
        'str.Append("</script>")

        Return str.ToString()

    End Function

    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreRender
        _dataSource = xdsEvents
        CreateMap()
    End Sub
End Class
